
import drop.*;
import test.*;

import processing.pdf.*;

SDrop drop;

String dropUrl;

String prompt = "drag and drop a folder with picture files inside";

void setup() {
  size(400, 400);
  drop = new SDrop(this);
}

void draw() {
  background(0xFF);
  fill(0);
  text(prompt,20,20,width-40,height-40);
}

void keyPressed() {
}

void dropEvent(DropEvent theDropEvent) {
  dropUrl = theDropEvent.toString();
  thread("generate");
}

void generate() {
  String[] filesUrls = getAllFilesFrom(dropUrl);
  PVector size = new PVector(1, 1);
  prompt = "checking size";
  for (String f : filesUrls) {
    prompt = "checking file : "+f;
    try {
      PImage im = loadImage(f);
      size.x = max(size.x, im.width);
      size.y = max(size.y, im.height);
      prompt = f + " is not a valide image file, skipping";
    }
    catch(Exception e) {
      prompt = f + " is not a valide image file, skipping";
    }
  }
  String outputUrl = dropUrl+"/output.pdf";
  PGraphics pdf = createGraphics(floor(size.x), floor(size.y), PDF, outputUrl);
  boolean firstPafe = true;
  pdf.beginDraw();
  for (String f : filesUrls) {
    prompt = "loading file "+f;
    try {
      if (!firstPafe) ((PGraphicsPDF)pdf).nextPage();
      firstPafe = false;
      PImage im = loadImage(f);
      pdf.imageMode(CENTER);
      pdf.background(0xFF);
      pdf.image(im, floor(size.x/2), floor(size.y/2));
    } 
    catch(Exception e) {
      prompt = f + " is not a valide image file, skipping";
    }
  }
  pdf.dispose();
  pdf.endDraw();
  prompt = "PDF saved to "+outputUrl;
}
